//***************************************************************************************************************************************************
//                            Программа Блока контроля транзисторного усилителя мощности и блока защит на TFT_HX8357
//                                           г.Снежное, ДНР, D0ITC, D0ISM 1января - 13апреля 2018года
//***************************************************************************************************************************** Подключаем библиотеки
#include <DS1307RTC.h>                                                 //подключаем библиотеку модуля часов реального времени DS3231
#include <Time.h>                                                      //подключаем библиотеку получения информации о текущем времени и дате
#include <TimeLib.h>                                                   //дополнение к "Time.h" макросы для временных констант и преобразования единиц времени
#include <Wire.h>                                                      //подключаем библиотеку I2C
#include <TonePlayer.h>                                                //подключаем библиотеку формирования тона бипера
#include <EEPROM.h>                                                    //подключаем библиотеку EEPROM
#include <TFT_HX8357.h>                                                //подключаем библиотеку для индикатора HX8357
#include <ACS712.h>                                                    //подключаем библиотеку для датчика ACS712
#include <OneWire.h>                                                   //подключаем библиотеку для датчика ds18b20
#include <sav_button.h>                                                //подключаем библиотеку для работы с кнопками
#include "Free_Fonts.h"                                                //подключаем шрифт Free_Fonts
//********************************************************************************************************************************* Задаём константы
#define ACS712_20_AMPERS 0.100                                         //константа выбора датчика 20А
#define ACS712_30_AMPERS 0.066                                         //константа выбора датчика 30А
#define ACS758_50_AMPERS 0.040                                         //константа выбора датчика 50А
#define TFT_GREY40 0x2945                                              //градация серого цвета(темнее)
#define TFT_GREY60 0x39E7                                              //градация серого цвета(светлее)
#define R1 100.0                                                       //константа входного делителя вольтметра R1(100K)
#define D0 0                                                           //константа порта подключения дешифратора ФНЧ(D0)
#define D1 1                                                           //константа порта подключения дешифратора ФНЧ(D1)
#define D2 2                                                           //константа порта подключения дешифратора ФНЧ(D2)
#define D3 3                                                           //константа порта подключения дешифратора ФНЧ(D3)
#define BCD_A_IN  A8                                                   //константа порта A8 подключения по стандарту Yaesu BCD
#define BCD_B_IN  A9                                                   //константа порта A9 подключения по стандарту Yaesu BCD
#define BCD_C_IN  A10                                                  //константа порта A10 подключения по стандарту Yaesu BCD
#define BCD_D_IN  A11                                                  //константа порта A11 подключения по стандарту Yaesu BCD
#define att3dB 4                                                       //константа порта подключения аттенюатора -3дБ
#define att6dB 5                                                       //константа порта подключения аттенюатора -6дБ
#define TX 7                                                           //константа порта подключения транзисторного ключа перевода УМ на передачу
#define pttIN 8                                                        //константа порта подключения педали PTT
#define Fantemp 9                                                      //константа порта подключения транзисторного ключа вентилятора
#define PTTKey 10                                                      //константа порта для первоначальной записи в EEPROM
#define ATTKey 11                                                      //константа инвертирования цвета дисплея
#define BNDKey 12                                                      //константа ориентации дисплея
#define in120 14                                                       //константа порта подключения внешнего делителя мощности 120Вт
#define Freq 47                                                        //константа порта измерения частоты входного сигнала 
#define DS_UPDATE_TIME 1000                                            //интервал времени опроса датчика темпертуры
    TFT_HX8357 tft = TFT_HX8357();                                     //инициализация дисплея
    OneWire ds(A3);                                                    //инициализация ds18b20    
    ACS712 sensor(ACS712_20A,A5);                                      //инициализация ACS712 20A
    TonePlayer tone4 (TCCR4A,TCCR4B,OCR4AH,OCR4AL,TCNT4H,TCNT4L);      //вывод тонального сигнала на вывод D6
//****************************************************************************************************************************** Назначаем переменные
    SButton button1(13,50,500,0,0);                                    //конфигурация кнопоки BYPASS/POWER ON ------------------------------------- B
    SButton button2(12,50,500,600,200);                                //конфигурация кнопоки BAND(BAND "MANUAL", "YAESU", "ICOM", "AUTO")          U
    SButton button3(11,50,500,600,100);                                //конфигурация кнопоки ATT(VOX)                                              T
    SButton button4(10,50,500,600,100);                                //конфигурация кнопоки PTT(PWR VIEW), в скобках длинное нажатие              T
    int flag_PTT, flag_power=0;                                        //флаги перевода УМ на передачу кнопкой PTT и кнопки POWER ON/BYPASS         O
    int pwr_on, PTT, beep=1;                                           //переменные кнопок PTT, BEEPER и POWER ON/BYPASS, выбраны при загрузке      N
    int flag_beeper, flag_beep=0;                                      //флаги кнопки управления бипереом и звукового сигнала --------------------- * 
    int valAutoATT=0;                                                  //счётчик времени задержки отключения аттенюатора в режиме AutoATT           A
    long AutoATTMillis=0;                                              //начальное значение для счетчика millis AutoATT                             T
    int att;                                                           //переменная выбора режима ATT                                               T
    int flag_autoATT, flag_auto3dB=0;                                  //флаги управления ATT                                                       *
    int ATTDelay=0;                                                    //переменная установки отпускания AUTO ATT в режиме МЕНЮ ------------------- *  
    int valvox=0;                                                      //счётчик времени отпускания VOX ------------------------------------------- *
    int VOXDelay=0;                                                    //переменная установки задержки отпускания VOX в режиме МЕНЮ                 V
    long VoxMillis=0;                                                  //начальное значение для счетчика millis VOX                                 O
    int flag_vox=0;                                                    //флаг управления режимом VOX                                                X
    int vox=1;                                                         //переменная управления режимом VOX ---------------------------------------- *
    int band;                                                          //переменная переключения диапазонов --------------------------------------- B
    int flag_mode_band=1;                                              //флаг фиксации состояния индикации режимов переключения диапазонов          A 
    int flag_mode=0;                                                   //флаг выбора режима переключения диапазонов                                 N
    int mode_band;                                                     //переменная выбора режимов переключения диапазонов ------------------------ D
    int band_get;                                                      //переменная полученного диапазона в режиме "AUTO" ------------------------- A
    int flag_band_switch, frq_vox=0;                                   //флаг подтверждения переключения диапазона и переменная блокировки TX       U
    float frq, frq_old1, frq_old2, frq_old3=0;                         //переменные частоты входного сигнала                                        T
    int frq_get=0;                                                     //переменная после сравнения частоты для шифрации                            O
    int BandDelay;                                                     //переменная задержки переключения диапазонов в режиме авто                  *
    volatile unsigned long timerCounts;                                //таймер расчёта при измерении частоты входного сигнала                      *
    volatile boolean counterReady;                                     //конечный подсчет                                                           B
    unsigned long overflowCount;                                       //расчёт переполнения                                                        A
    unsigned int timerTicks;                                           //таймер прерываний                                                          N
    unsigned int timerPeriod;                                          //таймер периода ----------------------------------------------------------- D
    bool statealarm=false;                                             //переменная состояния флага всех аварийных ситуаций ----------------------- *
    long TONE=0;                                                       //переменная тона звучания сигналов аварийных ситуаций                       *
    int N, Time=0;                                                     //переменные количества звуковых сигналов и времени между ними               A
    int flag_erroralarm=0;                                             //флаг аварийной ситуации по error                                           L
    int flag_tempalarm=0;                                              //флаг аварийной ситуации по температуре                                     A
    int flag_curalarm=0;                                               //флаг аварийной ситуации по току                                            R
    int flag_swralarm=0;                                               //флаг аварийной ситуации по КСВ                                             M
    int flag_inputalarm=0;                                             //флаг аварийной ситуации по уровню входного сигнала                         *
    int flag_voltagealarm=0;                                           //флаг аварийной ситуации по напряжению ------------------------------------ *
    int Scale;                                                         //переменная выбора выходной мощности -------------------------------------- *
    int Acs;                                                           //переменная выбора датчика тока                                             *
    float l=7.746; float h=15.492;                                     //переменные вычисления мощности 30Вт и 120Вт                                P
    int pwr_view;                                                      //переменная для смены вывода на экран часов или информационной строки       O
    int PWRi,PWR,PWRf;                                                 //переменные входных мощностей 30Вт и 120Вт                                  W
    float temp,U4,U5,U6,I4,vin,u,Psupply;                              //переменные температуры, вольтметра, амперметра, КПД и подводимой мощности  E
    int DelayPtt=0;                                                    //переменная счётчика задержки срабатывания TX                               R
    int InvDisp=0;                                                     //переменная инвертирования цвета дисплея ---------------------------------- *
    int BORDER;                                                        //переменная изменения цвета окантовок рамки ------------------------------- *
    int TFanOff,TFanOn,TFanMax;                                        //переменные управления вентилятором от температуры                          *
    int Imax,Vmin,Vmax;                                                //переменные тока и напряжения для срабатывания защиты                       *
    int ATToff,ATT3dB,ATT6dB;                                          //переменные срабатывания защиты в "ATT OFF", "ATT-3dB" и "ATT-6dB"          M
    int ATTauto,ATTalarm;                                              //переменные мощности срабатывания аттенюатора в "ATT AUTO" и защиты         E
    float SWRmax; int Tonbeep;                                         //переменные максимального КСВ для срабатывания защиты и тона бипера         N
    int TimeBeep;                                                      //переменная включения/выключения "TimeBeep"                                 U
    float divider;                                                     //переменная входного делителя вольтметра R2(10K)                            *
    int Length,Reserve;                                                //переменная переключения вывода дня недели                                  *
    int RotationDisp;                                                  //переменная смены ориентации дисплея -------------------------------------- *
    int RefreshTime;                                                   //переменная времени возобновления счёта усреднения ------------------------ *
    byte tMSB, tLSB;                                                   //переменные измерения температуры модуля DS3231                             T
    float my_temp;                                                     //переменная вызова подпрограммы измерения температуры модуля DS3231         с
    int flag_clock=0;                                                  //флаг подачи звукового сигнала через каждые 15 минут ---------------------- *
    unsigned long dsLastUpdateTime=0;                                  //переменная времени опроса
void startCounting (unsigned int ms){//******************************************************************************* Подпрограмма измерения частоты
    counterReady=false;                                                //готовность счётчика
    timerPeriod=ms;                                                    //количество импульсов на входе за 1 мс
    timerTicks=0;                                                      //сброс счетчика прерываний
    overflowCount=0;                                                   //счётчик переполнений
    TCCR2A=0; TCCR2B=0; TCCR5A=0; TCCR5B=0;                            //сброс таймера 2 и таймера 5
    TIMSK5=bit(TOIE1);                                                 //таймер 5-подсчет импульсов на pin D47, прерывание при переполнении таймера 5
    TCCR2A=bit(WGM21) ;                                                //режим CTC
    OCR2A=123;                                                         //подсчёт 125 тиков для получения 1мс(корректировка показаний) 
    TIMSK2=bit(OCIE2A);                                                //timer 2-прерывание каждую 1 мс, включаем прерывание Timer2
    TCNT2=0; TCNT5=0;                                                  //сброс счётчиков 2 и 5
    GTCCR=bit(PSRASY);                                                 //сброс предделителя, таймер 2 
    TCCR2B=bit(CS20)|bit(CS22);                                        //предделитель на 128, запуск таймера 5 
    TCCR5B=bit(CS50)|bit(CS51)|bit(CS52);}                             //чтение частоты на T4 pin (D47)   
    ISR (TIMER5_OVF_vect){++overflowCount;}                            //подсчет числа переполнения счетчика 5, конец TIMER5_OVF_vect 
    ISR (TIMER2_COMPA_vect){                                           //таймер 2 прерываний запускается аппаратным таймером 2 каждую 1мс=1000Гц
    unsigned int timer5CounterValue;                                   //получить значение счетчика,перед его изменением
    timer5CounterValue=TCNT5;                                          //см.datasheet, (доступ к 16-битным регистрам)
  if (++timerTicks<timerPeriod) return;                                //-------------------------------------------- 
  if (TIFR5&TOV5)overflowCount++;                                      //при переполнении
    TCCR5A=0; TCCR5B=0;                                                //обнуляем таймер 5
    TCCR2A=0; TCCR2B=0;                                                //обнуляем таймер 2
    TIMSK2=0; TIMSK5=0;                                                //отключаем прерывания Timer2 и Timer5  
    timerCounts=(overflowCount<<16)+timer5CounterValue;                //подсчёт переполнений, каждое переполнение больше 65536 
    counterReady=true;}                                                //установить глобальный флаг для периода конечного подсчета
void setup(){//========================================================================================================= Установочная часть программы
    tft.init();                                                        //инициализация дисплея
    button1.begin(); button2.begin();                                  //инициализация кнопок
    button3.begin(); button4.begin();                                  //--------------------
    pinMode(D0,OUTPUT);                                                //назначаем вывод(D0)на выход, подключение дешифратора ФНЧ(0) 
    pinMode(D1,OUTPUT);                                                //назначаем вывод(D1)на выход, подключение дешифратора ФНЧ(1)
    pinMode(D2,OUTPUT);                                                //назначаем вывод(D2)на выход, подключение дешифратора ФНЧ(2)
    pinMode(D3,OUTPUT);                                                //назначаем вывод(D3)на выход, подключение дешифратора ФНЧ(3)
    pinMode(BCD_A_IN, INPUT);                                          //назначаем вывод(A8)на вход
    pinMode(BCD_B_IN, INPUT);                                          //назначаем вывод(A9)на вход
    pinMode(BCD_C_IN, INPUT);                                          //назначаем вывод(A10)на вход
    pinMode(BCD_D_IN, INPUT);                                          //назначаем вывод(A11)на вход
    pinMode(att3dB,OUTPUT);                                            //назначаем порт управления att-3dB на выход(4)
    pinMode(att6dB,OUTPUT);                                            //назначаем порт управления att-6dB на выход(5)
    pinMode(6,OUTPUT);                                                 //назначаем порт пьезо излучателя на выход(6) 
    pinMode(TX,OUTPUT);                                                //назначаем управление PTT на выход(7)
    pinMode(pttIN,INPUT_PULLUP);                                       //назначаем вывод подключения педали PTT на вход с внутренней подтяжкой к +(8)
    pinMode(Fantemp,OUTPUT);                                           //назначаем управление вентилятором на выход(9)
    pinMode(PTTKey,INPUT_PULLUP);                                      //назначаем вывод кнопки PTT на вход с внутренней подтяжкой к +(10)
    pinMode(ATTKey,INPUT_PULLUP);                                      //назначаем вывод кнопки ATT на вход с внутренней подтяжкой к +(11)
    pinMode(in120,OUTPUT);                                             //назначаем вывод подключения внешнего делителя на выход(14)
    pinMode(Freq,INPUT);                                               //назначаем порт измерения частоты на вход(47)
  if (digitalRead(PTTKey)==LOW){EEPROM.update(0,5);EEPROM.update(7,20);//при включении питания с удержанием кнопки PTTKey
    EEPROM.update(1,5);   EEPROM.update(2,1);    EEPROM.update(3,1);   //записываем текущее состояние режимов
    EEPROM.update(4,2);   EEPROM.update(5,2);    EEPROM.update(6,0);   //в соответствующие ячейки EEPROM
    EEPROM.update(10,15); EEPROM.update(11,2);   EEPROM.update(12,15); //-------------------------------
    EEPROM.update(13,45); EEPROM.update(14,50);  EEPROM.update(15,28); //-------------------------------
    EEPROM.update(16,30); EEPROM.update(17,31);  EEPROM.update(20,15); //-------------------------------
    EEPROM.update(21,25); EEPROM.update(22,30);  EEPROM.update(23,15); //-------------------------------
    EEPROM.update(24,25); EEPROM.put(27,2.8);    EEPROM.update(26,9);  //-------------------------------
    EEPROM.update(25,1);  EEPROM.update(18,100); EEPROM.put(31,10.0);  //-------------------------------
    EEPROM.update(8,1);   EEPROM.update(9,2);    EEPROM.update(19,3);  //-------------------------------
    EEPROM.update(35,2);  EEPROM.update(36,2);}                        //в соответствующие ячейки EEPROM
  if (digitalRead(ATTKey)==LOW){InvDisp=EEPROM.read(6);                //при включении питания с удержанием кнопки ATTKey читаем текущее значение ячейки 6 в "InvDisp"
    EEPROM.write(6,!InvDisp);}                                         //инвертируем состояние и пишем в 6 ячейку EEPROM
  if (digitalRead(BNDKey)==LOW){RotationDisp=EEPROM.read(19);          //при включении питания с удержанием кнопки ATTKey читаем текущее значение ячейки 19 в "RotationDisp"
  if (RotationDisp==3){EEPROM.write(19,1);}                            //если значение RotationDisp==3 пишем в ячейку 19 1
  if (RotationDisp==1){EEPROM.write(19,3);}}                           //если значение RotationDisp==1 пишем в ячейку 19 3
    tft.invertDisplay(EEPROM.read(6));                                 //читаем содержимое ячейки 6 и выводим нормальный или инверсный цвет дисплея
    tft.setRotation(EEPROM.read(19));                                  //читаем содержимое ячейки 19 и выводим ориентацию дисплея
    BORDER=EEPROM.read(36);                                            //читаем из 36 ячейки EEPROM состояние BORDER
//****************************************************************************************************************************************** Заставка    
    tft.fillScreen(TFT_GREY60);                                        //заливаем экран серым цветом
    tft.fillRoundRect(6,6,468,308,8,TFT_BLACK);                        //рисуем черный прямоугольник фона
  if (BORDER==1){BORDER=TFT_GREEN;}                                    //если BORDER==1 включается зелёный цвет окантовок рамки
  if (BORDER==2){BORDER=TFT_SILVER;}                                   //если BORDER==2 включается серебряный цвет окантовок рамки
  if (BORDER==3){BORDER=TFT_PINK;}                                     //если BORDER==3 включается розовый цвет окантовок рамки
  for(int i=0; i<2; i++){                                              //включаем цикл
    tft.drawRect(0+i,0+i,480-i*2,320-i*2,BORDER);                      //рисуем наружную окантовку
    tft.drawRoundRect(6+i,6+i,468-i*2,308-i*2,8-i,BORDER);}            //рисуем внутреннюю окантовку с закруглёнными углами
    tft.setFreeFont(FSBI24); tft.setTextColor(TFT_DARKGREY);           //подключаем внешний шрифт FSBI24, выбираем цвет текста    
    tft.drawCentreString("PA Control Unit",243,103,1);                 //выводим подложку надписи "PA Control Unit"
    tft.drawCentreString("With Protection",243,153,1);                 //выводим подложку надписи "With Protection"
    tft.setTextColor(TFT_CYAN);                                        //устанавливаем цвет текста
    tft.drawCentreString("PA Control Unit",240,100,1);                 //выводим надпись "PA Control Unit"
    tft.drawCentreString("With Protection",240,150,1);                 //выводим надпись "With Protection"
    tft.setFreeFont(FSBI18); tft.setTextColor(TFT_DARKGREY);           //подключаем внешний шрифт FSBI18, выбираем цвет текста  
    tft.drawCentreString("D0ITC 2018 D0ISM",240,260,1);                //выводим надпись "D0ISM & D0ICT"
    ds.reset(); ds.write(0xCC); ds.write(0x44);                        //подготавливаем датчик температуры
    delay(1000);                                                       //задержка 2с  
    preparing_the_screen();}                                           //вызываем подпрограмму подготовки экрана
void loop(){//========================================================================================================================= Основной цикл
  unsigned long AverageLevel = millis();                               //назначаем переменную отсчета времени усреднения входных сигналов AverageLevel
    float U1=0,U2=0,U4=0;U5=0;                                         //переменные прямой и обратной волны выходной мощности, входной мощности
    int ReadCnt=0;                                                     //назначаем переменную инкрементного счетчика
  while ((millis()-AverageLevel)<RefreshTime){                         //пока отсчет времени не сравняется с константой RefreshTime:
    U1 += analogRead(A0);                                              //суммируем значения U1 с порта А0
    U2 += analogRead(A1);                                              //суммируем значения U2 с порта А1
    U4 += analogRead(A4);                                              //суммируем значения U4 с порта А4
    U5 += analogRead(A6);                                              //суммируем значения U5 с порта А6
    U6 += analogRead(A7);                                              //суммируем значения U6 с порта А7
    I4 += sensor.getCurrentDC();                                       //суммируем значения I4 с порта А5
    ReadCnt++;}                                                        //увеличиваем значение счетчика ReadCnt на 1(26раз)
    U1 = U1 / ReadCnt;                                                 //усредняем значение U1
    U2 = U2 / ReadCnt;                                                 //усредняем значение U2
    U4 = U4 / ReadCnt;                                                 //усредняем значение U4
    U5 = U5 / ReadCnt;                                                 //усредняем значение U5
    U6 = U6 / ReadCnt;                                                 //усредняем значение U6
    I4 = I4 / ReadCnt;                                                 //усредняем значение I4
    set_temp(); energy(I4,U4,U1,U2); alc(U6);                          //вызываем подпрограммы set_temp ,energy и alc
//**************************************************************************************************************************************** Расчёт КСВ
    float SWR=0;                                                       //назначаем переменную расчёта КСВ  
  if ((U1==0)&&(U5==0)){SWR=1;}                                        //если прямая и обратная волна равны нулю выводим "1.00"  
  if ((U1!=0)&&(U5!=0)&&(U1==U5)||(U5>U1)){SWR=9.99;}                  //если U1 и U5 не равны нулю и U1==U5 или U5>U1, то КСВ равно 9.99
  if (U1>U5){SWR=(U1+U5)/(U1-U5);}                                     //если U1>U5, то расчитываем значение КСВ 
  if (SWR>=9.99){SWR=9.99;}                                            //ограничиваем значение КСВ на уровне 9.99
     tft.setTextPadding(50);                                           //включаем обновление подложки шрифта
  if (SWR<SWRmax){tft.setTextColor(TFT_GREEN,TFT_BLACK);               //если SWR<SWRmax выбираем зелёный цвет надписи
     tft.drawFloat(SWR,2,107,190,4);}                                  //выводим значение КСВ красным цветом
  if (SWR>=SWRmax){tft.setTextColor(TFT_RED,TFT_BLACK);                //если SWR>=SWRmax, выбираем цвет надписи
    tft.drawFloat(SWR,2,107,190,4);}                                   //выводим значение КСВ красным цветом  
  if ((SWR>=SWRmax)&&(statealarm==false)){flag_swralarm=1;             //если SWR>=SWRmaxи "statealarm==false" устанавливаем "flag_swralarm" в 1 
    tft.setTextColor(TFT_RED,TFT_BLACK);                               //выбираем красный цвет надписи
    tft.setTextPadding(158); TONE=500; Time=150; N=3;                  //включаем обновление подложки шрифта, включаем тон частотой 500Гц через 150мc
    tft.drawString("SWR  HIGH!!!",200,120,4);}                         //выводим надпись "SWR  HIGH!!!" красным цветом
//******************************************************************************************************************* Сигнализация аварийных ситуаций
  if (statealarm==false){                                              //если "statealarm==false" 
  if ((flag_tempalarm==1)||(flag_curalarm==1)||(flag_swralarm==1)||    //при совпадении одного из флагов
    (flag_inputalarm==1)||(flag_voltagealarm==1)||(flag_erroralarm==1))//------------------------------- 
    {tft.setTextPadding(50); tft.drawCentreString("",440,120,4);       //затираем надпись "TX"
    tft.fillRoundRect(8,108,170,56,5,TFT_BLACK);                       //меняем цвет фона и затираем надписи
    tft.setTextColor(TFT_RED,TFT_BLACK); tft.setFreeFont(FSSB12);      //выбираем цвет и шрифт текста
    tft.drawCentreString("BYPASS",92,128,1);                           //выводим надпись "BYPASS" 
    digitalWrite(TX,LOW); PTT=2; flag_PTT=0; pwr_on=2; flag_power=0;   //на выводе TX низкий уровень, "flag_power=0" 
    draw_inp_pwr120();                                                 //включаем масштаб входной мощности 120Вт 
  for (int i=0;i<N;i++){tone4.tone(TONE);                              //включаем цикл N-ного повторения тонального сигнала
  for (int i=0;i<6;i++){tft.drawRect(i,i,480-i*2,320-i*2,TFT_RED);}    //включаем цикл, мигаем наружной окантовкой красным цветом
    delay(Time);                                                       //в зависимости от сработанной аварии меняем длительность тонального сигнала
    tone4.noTone();                                                    //выключаем тональный сигнал
  for (int i=0;i<2;i++){tft.drawRect(i,i,480-i*2,320-i*2,BORDER);}     //восстанавливаем серебряный цвет наружной рамки
  for (int i=0;i<4;i++){tft.drawRect(2+i,2+i,476-i*2,316-i*2,0x39E7);} //восстанавливаем серый цвет наружной рамки
    delay(Time);}                                                      //в зависимости от сработанной аварии меняем длительность паузы тонального сигнала
    statealarm=true;}}                                                 //по окончании цикла устанавливаем сосотояние флага "statealarm=true"
//************************************************************************************************************** Сигнализация переключения диапазонов
  if (flag_band_switch==1){ N; tone4.tone(TONE);                       //если "flag_band_switch==1" один раз подаём тональный сигнал
  for (int i=0;i<6;i++){tft.drawRect(i,i,480-i*2,320-i*2,TFT_BLUE);}   //включаем цикл, один раз мигаем наружной окантовкой
    delay(BandDelay); tone4.noTone();                                  //устанавливаем длительность тонального сигнала, выключаем тональный сигнал
  for (int i=0;i<2;i++){tft.drawRect(i,i,480-i*2,320-i*2,BORDER);}     //восстанавливаем серебряный цвет наружной рамки
  for (int i=0;i<4;i++){tft.drawRect(2+i,2+i,476-i*2,316-i*2,0x39E7);}}//восстанавливаем серый цвет наружной рамки
//**************************************************************************************************************************** Сигнализация "кукушки"
  if ((flag_clock==1)&&(TimeBeep==2)){ N; tone4.tone(TONE);            //если "flag_clock==1" и "TimeBeep==2" один раз подаём тональный сигнал
  for (int i=0;i<6;i++){tft.drawRect(i,i,480-i*2,320-i*2,TFT_PINK);}   //включаем цикл, один раз мигаем наружной окантовкой
    delay(Time); tone4.noTone();                                       //устанавливаем длительность тонального сигнала, выключаем тональный сигнал
  for (int i=0;i<2;i++){tft.drawRect(i,i,480-i*2,320-i*2,BORDER);}     //восстанавливаем серебряный цвет наружной рамки
  for (int i=0;i<4;i++){tft.drawRect(2+i,2+i,476-i*2,316-i*2,0x39E7);}}//восстанавливаем серый цвет наружной рамки
//************************************************************************************************************************************ Кнопка питания  
  switch(button1.Loop()){                                              //описывем работу кнопки "BYPASS/POWER ON"    
    case SB_CLICK: {pwr_on++; beeper();} if (pwr_on>2) {pwr_on=1;}     //определяем алгоритм работы кнопки BYPASS/POWER ON по короткому нажатию с бипером
  if (pwr_on==1) {tft.fillRoundRect(8,108,170,56,5,TFT_DARKCYAN);      //есл pwr_on==1 меняем цвет фона надписи на тёмно-голубой
    tft.setFreeFont(FSSB12); tft.setTextColor(TFT_GREEN,TFT_DARKCYAN); //выбираем шрифт и цвет надписи 
    tft.drawCentreString("POWER   ON",92,128,1); flag_power=1;         //выводим надпись "POWER   ON", переключаем "flag_power" в 1
    draw_inp_pwr30(); statealarm=false; flag_auto3dB=0;                //выводим прорисовку шкалы 30Вт, "statealarm=false", сбрасываем флаги 
    frq_vox=0; flag_inputalarm=0; flag_voltagealarm=0;                 //"flag_inputalarm", "flag_voltagealarm", "flag_auto3d", 
    flag_swralarm=0; flag_curalarm=0; flag_tempalarm=0;                //"flag_swralarm", "flag_curalarm" и "flag_tempalarm"
    flag_erroralarm=0;}                                                //"flag_erroralarm" в ноль
  if (pwr_on==2) {tft.fillRoundRect(8,108,170,56,5,TFT_BLACK);         //при pwr_on=2 заливаем окно в черный цвет,
    tft.setTextColor(TFT_RED,TFT_BLACK);                               //цвет шрифта красный
    tft.setFreeFont(FSSB12); tft.drawCentreString("BYPASS",92,128,1);  //шрифт FSSB12, выводим "BYPASS"
    tft.setTextPadding(50); tft.drawCentreString("",440,120,4);        //стираем "VOX" или "TX"
    tft.setTextPadding(160); tft.drawString("",200,120,4);             //стираем надписи всех аттенюаторов
    flag_power=0; PTT=2; digitalWrite(TX,LOW); draw_inp_pwr120();      //устанавливаем флаг flag_power=0, режим приема, выводим в порт TX 0, рисуем шкалу 120Вт
    EEPROM.update(0,band); EEPROM.update(1,mode_band);                 //записываем состояние режимов "band" и "mode_band" в EEPROM
    EEPROM.update(2,att); EEPROM.update(3,vox);                        //записываем состояние режимов "att" и "vox" в EEPROM
    EEPROM.update(5,pwr_view);} break;                                 //записываем состояние режима "pwr_view"
    case SB_LONG_CLICK: pwr_on=2; flag_power=0; PTT=2; beeper();       //длинным нажатием
    digitalWrite(TX,LOW);                                              //выключаем "TX" и входим в меню с бипером
    EEPROM.update(0,band); EEPROM.update(1,mode_band);                 //записываем состояние режимов "band" и "mode_band" в EEPROM
    EEPROM.update(2,att); EEPROM.update(3,vox);                        //записываем состояние режимов "att" и "vox" в EEPROM
    EEPROM.update(5,pwr_view); menu(); break;}                         //записываем состояние режима "pwr_view"
//*************************************************************************************************************************** Переключение диапазонов
  switch (button2.Loop()){                                             //описываем работу кнопки "BAND"
    case SB_CLICK: if (flag_mode==1){band++; beeper();}                //по короткому нажатию в режиме "MANUAL"
  if (band>10) {band=1;} break;                                        //переключаем диапазоны с бипером
    case SB_LONG_CLICK: mode_band++; beeper(); flag_mode_band=1;       //по длинному нажатию с бипером устанавливаем "flag_mode_band=1"
  if (mode_band>5) {mode_band=1;} break;}                              //переключаем диапазоны
    tft.setTextPadding(100); tft.setTextColor(TFT_GREEN,TFT_BLACK);    //включаем обновление подложки шрифта и выбираем цвет текста
  if (flag_mode==2){                                                   //если выбран режим "YAESU-817" "flag_mode==2"
  switch (analogRead(A2)){                                             //читаем состояние входа А2
    case 0 ... 70:      band=1; break;                                 //-- 160m ------ (0...0,34v) --------------
    case 71 ... 140:    band=2; break;                                 //-- 80m ------- (0,34...0,68v) -----------
    case 141 ... 210:   band=3; break;                                 //-- 40m ------- (0,68...1,02v) -----------
    case 211 ... 272:   band=4; break;                                 //-- 30m ------- (1,02...1,36v) -----------
    case 273 ... 344:   band=5; break;                                 //-- 20m ------- (1,36...1,7v)-------------
    case 345 ... 470:   band=6; break;                                 //-- 17m ------- (1,7...2,04v) ------------
    case 471 ... 485:   band=7; break;                                 //-- 15m ------- (2,04...2,38v) -----------
    case 486 ... 538:   band=8; break;                                 //-- 12m ------- (2,38...2,72v) -----------
    case 539 ... 608:   band=9; break;                                 //-- 10m ------- (2,72...3,06v) -----------
    case 609 ... 1023: band=10; break;}}                               //-- 6m -------- (3,06...3,4v) ------------
  if (flag_mode==3){                                                   //если выбран режим "YAESU-BCD" "flag_mode==3"
    bool bcdA=0;                                                       //Yaesu вывод 4 разъёма DIN8
    bool bcdB=0;                                                       //Yaesu вывод 5 разъёма DIN8
    bool bcdC=0;                                                       //Yaesu вывод 6 разъёма DIN8
    bool bcdD=0;                                                       //Yaesu вывод 7 разъёма DIN8
  if (analogRead(BCD_A_IN)>409){bcdA=true;}                            //если на входе порта A8 больше 2в, bcdA=true
  else {bcdA=false;}                                                   //иначе bcdA=false
  if (analogRead(BCD_B_IN)>409){bcdB=true;}                            //если на входе порта A9 больше 2в, bcdB=true
  else {bcdB=false;}                                                   //иначе bcdB=false
  if (analogRead(BCD_C_IN)>409){bcdC=true;}                            //если на входе порта A10 больше 2в, bcdC=true
  else {bcdC=false;}                                                   //иначе bcdC=false
  if (analogRead(BCD_D_IN)>409){bcdD=true;}                            //если на входе порта A11 больше 2в, bcdD=true
  else {bcdD=false;}                                                   //иначе bcdD=false
  if (bcdA&&!bcdB&&!bcdC&&!bcdD) {band= 1;}                            //--A=1--B=0--C=0--D=0------- 160m ---------
  if (!bcdA&&bcdB&&!bcdC&&!bcdD) {band= 2;}                            //--A=0--B=1--C=0--D=0-------- 80m ---------
  if (bcdA&&bcdB&&!bcdC&&!bcdD)  {band= 3;}                            //--A=1--B=1--C=0--D=0-------- 40m ---------
  if (!bcdA&&!bcdB&&bcdC&&!bcdD) {band= 4;}                            //--A=0--B=0--C=1--D=0-------- 30m ---------
  if (bcdA&&!bcdB&&bcdC&&!bcdD)  {band= 5;}                            //--A=1--B=0--C=1--D=0-------- 20m ---------
  if (!bcdA&&bcdB&&bcdC&&!bcdD)  {band= 6;}                            //--A=0--B=1--C=1--D=0-------- 17m ---------
  if (bcdA&&bcdB&&bcdC&&!bcdD)   {band= 7;}                            //--A=1--B=1--C=1--D=0-------- 15m ---------
  if (!bcdA&&!bcdB&&!bcdC&&bcdD) {band= 8;}                            //--A=0--B=0--C=0--D=1-------- 12m ---------
  if (bcdA&&!bcdB&&!bcdC&&bcdD)  {band= 9;}                            //--A=1--B=0--C=0--D=1-------- 10m ---------
  if (!bcdA&&bcdB&&!bcdC&&bcdD)  {band=10;}                            //--A=0--B=1--C=0--D=1--------- 6m ---------
  if (!bcdA&&!bcdB&&!bcdC&&!bcdD){band=11;}}                           //--A=0--B=0--C=0--D=0------- error --------
  if (flag_mode==4){                                                   //если выбран режим "ICOM" "flag_mode==4"
  switch (analogRead(A2)){                                             //протокол icom с резистивным делителем 1/2
    case 0 ... 126:   band=4;  break;                                  //-- 30m 0,1v...1,2v --- (0...0,6v) -------
    case 127 ... 212: band=10; break;                                  //-- 6m 1,2v...2v ------ (0,6...1v) -------
    case 213 ... 265: band=9;  break;                                  //-- 10m-12m 2v...2,5v - (1...1,25v) ------
    case 266 ... 365: band=7;  break;                                  //-- 15v-17v 3v...3,5v - (1,5...1,75v) ----
    case 366 ... 485: band=5;  break;                                  //-- 20m 4v...4,5v ----- (2...2,25v) ------
    case 486 ... 590: band=3;  break;                                  //-- 40m 5v...5,5v ----- (2,5...2,75v) ----
    case 591 ... 700: band=2;  break;                                  //-- 80m 6v...6,5v ----- (3...3,25v) ------
    case 701 ... 818: band=1;  break;                                  //-- 160m 7v...8v ------ (3,5...4v) -------
    default: band=1; break;}}                                          //в любых других случаях включаем band1 160m
    startCounting(2); delay(2);                                        //выставляем 2мс для подсчёта частоты, задержка 2мс
    frq=((timerCounts*16)/100)/timerPeriod;                            //измеряем входную частоту, получаем "frq" для работы VOX в режимах кроме "AUTO"
  if ((flag_mode==5)&&(frq>16)){                                       //если выбран режим "AUTO"
  for (int i=0; i<3; i++){startCounting(2); delay(2);                  //включаем цикл и выставляем 2мс для подсчёта частоты, задержка 2мс
    frq=((timerCounts*16)/100)/timerPeriod;                            //измеряем входную частоту в МГц(шаг 100кГц)
  if (frq>frq_old1){frq_old1=frq;}}                                    //получаем наивысшую частоту "frq_old1"
  for (int i=0; i<3; i++){startCounting(2); delay(2);                  //включаем цикл и выставляем 2мс для подсчёта частоты, задержка 2мс
    frq=((timerCounts*16)/100)/timerPeriod;                            //измеряем входную частоту в МГц(шаг 100кГц)
  if (frq>frq_old2){frq_old2=frq;}}                                    //получаем наивысшую частоту "frq_old2"
  for (int i=0; i<3; i++){startCounting(2); delay(2);                  //включаем цикл и выставляем 2мс для подсчёта частоты, задержка 2мс
    frq=((timerCounts*16)/100)/timerPeriod;                            //измеряем входную частоту в МГц(шаг 100кГц)
  if (frq>frq_old3){frq_old3=frq;}}                                    //получаем наивысшую частоту "frq_old3"
  if ((frq_old1==frq_old2)&&(frq_old2==frq_old3)){frq_get=frq_old1;    //сравниваем три частоты и при их равенстве записываем в "frq_get"
    frq_vox=frq_old1;}                                                 //получаем переменную для задержки включения VOX в режиме "AUTO"
  switch (frq_get){                                                    //после цикла выбора наивысшей частоты и совпадения частот
    case 16 ... 31:   band_get=1; break;                               //получаем диапазон для переключения 160м(1)
    case 32 ... 50:   band_get=2; break;                               //получаем диапазон для переключения 80м (2)
    case 51 ... 80:   band_get=3; break;                               //получаем диапазон для переключения 40м (3)
    case 81 ... 120:  band_get=4; break;                               //получаем диапазон для переключения 30м (4)
    case 121 ... 160: band_get=5; break;                               //получаем диапазон для переключения 20м (5)
    case 161 ... 190: band_get=6; break;                               //получаем диапазон для переключения 17м (6)
    case 191 ... 230: band_get=7; break;                               //получаем диапазон для переключения 15м (7)
    case 231 ... 260: band_get=8; break;                               //получаем диапазон для переключения 12м (8)
    case 261 ... 300: band_get=9; break;                               //получаем диапазон для переключения 10м (9)
    case 301 ... 510: band_get=10;break;}                              //получаем диапазон для переключения 6м (10)
  if (band_get!=band){band=band_get; flag_band_switch=1;}              //если новый диапазон не совпадает со старым - переключаем диапазон и "flag_band_switch=1"
  if (frq<frq_old1){frq_old1=0; frq_old2=0; frq_old3=0;}}              //если новая частота меньше предыдущей обнуляем "frq_old1-3"
  switch (band){                                                       //переключаем диапазоны по кольцу
    case 1: tft.drawCentreString("160",64,263,6);                      //----------------- 160m -------------------
    digitalWrite(D0,HIGH); digitalWrite(D1,LOW);                       //вывод кода для дешифратора диапазонных ФНЧ
    digitalWrite(D2,LOW); digitalWrite(D3,LOW);  break;                //--------- D3=0--D2=0--D1=0--D0=1 ---------
    case 2: tft.drawCentreString("80",64,263,6);                       //------------------ 80m -------------------
    digitalWrite(D0,LOW); digitalWrite(D1,HIGH);                       //вывод кода для дешифратора диапазонных ФНЧ
    digitalWrite(D2,LOW); digitalWrite(D3,LOW);  break;                //--------- D3=0--D2=0--D1=1--D0=0 ---------
    case 3: tft.drawCentreString("40",64,263,6);                       //------------------ 40m -------------------
    digitalWrite(D0,HIGH); digitalWrite(D1,HIGH);                      //вывод кода для дешифратора диапазонных ФНЧ
    digitalWrite(D2,LOW); digitalWrite(D3,LOW);  break;                //--------- D3=0--D2=0--D1=1--D0=1 ---------
    case 4: tft.drawCentreString("30",64,263,6);                       //------------------ 30m -------------------
    digitalWrite(D0,LOW); digitalWrite(D1,LOW);                        //вывод кода для дешифратора диапазонных ФНЧ
    digitalWrite(D2,HIGH); digitalWrite(D3,LOW); break;                //--------- D3=0--D2=1--D1=0--D0=0 ---------
    case 5: tft.drawCentreString("20",64,263,6);                       //------------------ 20m -------------------
    digitalWrite(D0,HIGH); digitalWrite(D1,LOW);                       //вывод кода для дешифратора диапазонных ФНЧ
    digitalWrite(D2,HIGH); digitalWrite(D3,LOW); break;                //--------- D3=0--D2=1--D1=0--D0=1 ---------
    case 6: tft.drawCentreString("17",64,263,6);                       //------------------ 17m -------------------
    digitalWrite(D0,LOW); digitalWrite(D1,HIGH);                       //вывод кода для дешифратора диапазонных ФНЧ
    digitalWrite(D2,HIGH); digitalWrite(D3,LOW); break;                //--------- D3=0--D2=1--D1=1--D0=0 --------- 
    case 7: tft.drawCentreString("15",64,263,6);                       //------------------ 15m -------------------
    digitalWrite(D0,HIGH); digitalWrite(D1,HIGH);                      //вывод кода для дешифратора диапазонных ФНЧ
    digitalWrite(D2,HIGH); digitalWrite(D3,LOW); break;                //--------- D3=0--D2=1--D1=1--D0=1 --------- 
    case 8: tft.drawCentreString("12",64,263,6);                       //------------------ 12m -------------------
    digitalWrite(D0,LOW); digitalWrite(D1,LOW);                        //вывод кода для дешифратора диапазонных ФНЧ
    digitalWrite(D2,LOW); digitalWrite(D3,HIGH); break;                //--------- D3=1--D2=0--D1=0--D0=0 --------- 
    case 9: tft.drawCentreString("10",64,263,6);                       //------------------ 10m -------------------
    digitalWrite(D0,HIGH); digitalWrite(D1,LOW);                       //вывод кода для дешифратора диапазонных ФНЧ
    digitalWrite(D2,LOW); digitalWrite(D3,HIGH); break;                //--------- D3=1--D2=0--D1=0--D0=1 ---------
    case 10: tft.drawCentreString("6",64,263,6);                       //-------------------6m---------------------
    digitalWrite(D0,LOW); digitalWrite(D1,HIGH);                       //вывод кода для дешифратора диапазонных ФНЧ
    digitalWrite(D2,LOW); digitalWrite(D3,HIGH); break;                //--------- D3=1--D2=0--D1=1--D0=0 ---------
    case 11: tft.setTextColor(TFT_RED,TFT_BLACK);                      //выбираем красный цвет текста
    tft.drawCentreString("BAND",64,262,4);                             //----------------- BAND -------------------
    tft.drawCentreString("ERROR",64,287,4);                            //----------------- ERROR ------------------
    tft.fillRect(200,120,150,20,TFT_BLACK);                            //затираем строку
    flag_erroralarm=1; TONE=700; Time=200; N=2;                        //выбираем тон сигнала
    digitalWrite(D0,LOW); digitalWrite(D1,LOW);                        //вывод кода для дешифратора диапазонных ФНЧ
    digitalWrite(D2,LOW); digitalWrite(D3,LOW); break;}                //--------- D3=0--D2=0--D1=0--D0=0 --------- 
  if (flag_band_switch==1){flag_band_switch=1; TONE=3000;Time=150;N=1; //если "flag_band_switch==1" устанавливаем "flag_band_switch=1"
    flag_PTT=0; PTT=2;}                                                //при переключении диапазона блокируем выход PTT с кнопки PTT или педали
    tft.setTextColor(TFT_DARKGREY,TFT_BLACK);                          //выбираем цвет текста
  if(flag_mode_band==1){tft.setTextPadding(110);tft.setFreeFont(FSSB9);//если "flag_mode_band==1"
  switch (mode_band){                                                  //при длительном нажатии управляем режимами переключения диапазонов 
  case 1:tft.drawCentreString("MANUAL", 64, 245, 1);flag_mode=1;break; //выбор переключения диапазонов в режиме "MANUAL", "flag_mode=1"
  case 2:tft.drawCentreString("YAESU-817",63,245,1);flag_mode=2;break; //выбор переключения диапазонов по протоколу "YAESU-817", "flag_mode=2"
  case 3:tft.drawCentreString("YAESU-BCD",63,245,1);flag_mode=3;break; //выбор переключения диапазонов по протоколу "YAESU-BCD", "flag_mode=3" 
  case 4:tft.drawCentreString("BAND ICOM",63,245,1);flag_mode=4;break; //выбор переключения диапазонов по протоколу "BAND ICOM", "flag_mode=4"
  case 5:tft.drawCentreString("BAND AUTO",63,245,1);flag_mode=5;break;}//выбор переключения диапазонов в режиме "BAND AUTO", "flag_mode=5"
    flag_mode_band=0;}                                                 //сбрасываем "flag_mode_band=0"
//*************************************************************************************************************************************** Аттенюаторы
    tft.setTextPadding(158); tft.setTextColor(TFT_GREEN,TFT_BLACK);    //включаем обновление подложки шрифта и выбираем цвет текста
  if (flag_power==1){                                                  //если включен режим "POWER ON"
  switch (button3.Loop()){                                             //описываем работу кнопки "АТТ/VOX"
    case SB_CLICK: att++; beeper();if (att>4) {att=1;} break;          //определяем алгоритм работы кнопки ATT по короткому нажатию с бипером
    case SB_LONG_CLICK: vox++; beeper();if (vox>2) {vox=1;} break;}    //определяем алгоритм работы кнопки VOX по длинному нажатию с бипером
  switch (att) {                                                       //короткими нажатиями переключаем режимы аттенюаторов
    case 1:if (flag_auto3dB==0){flag_autoATT=1;                        //устанавливаем "flag_autoATT" в 1 
    tft.drawString("ATT AUTO",200,120,4);                              //выводим надпись "ATT AUTO",  
    digitalWrite(att3dB,LOW); digitalWrite(att6dB,LOW);} break;        //на выходах ATT-3dB и ATT-6dB низкие уровени 
    case 2:flag_autoATT=0;tft.drawString("ATT    OFF",200,120,4);break;//сбрасываем "flag_autoATT" в 0, выводим надпись "ATT  OFF"
    case 3:tft.drawString("ATT   -3dB",200,120,4);                     //выводим надпись "ATT:  -3dB"
    digitalWrite(att3dB,HIGH);digitalWrite(att6dB,LOW);  break;        //на выходе ATT-3dB высокий уровень, на выходе ATT-6dB низкий
    case 4:tft.drawString("ATT   -6dB",200,120,4);                     //выводим надпись "ATT:  -6dB"
    digitalWrite(att3dB,HIGH);digitalWrite(att6dB,HIGH) ;break;}       //на выходе ATT-6dB высокий уровень, на выходе ATT-3dB низкий
    tft.setTextPadding(158); tft.setTextColor(TFT_RED,TFT_BLACK);      //включаем обновление подложки шрифта и выбираем красный цвет текста
  if ((att==2)&&(PWRi>=ATToff)&&(flag_PTT==1)){                        //при совпадении условий и флага ***************************** ATT OFF
    flag_inputalarm=1; TONE=2500; Time=50; N=10;                       //устанавливаем флаг "flag_inputalarm" в 1 и включаем прерывистый звуковой сигнал
    tft.drawString("INP PWR Hi!",200,120,4);}                          //выводим надпись "INP PWR Hi!" красным цветом   
  if ((att==3)&&(PWRi>=ATT3dB)&&(flag_PTT==1)){                        //при совпадении условий и флага **************************** ATT -3дБ
    flag_inputalarm=1; TONE=2500; Time=50; N=10;                       //устанавливаем флаг "flag_inputalarm" в 1 и включаем прерывистый звуковой сигнал
    tft.drawString("INP PWR Hi!",200,120,4);}                          //выводим надпись "INP PWR Hi!" красным цветом                
  if ((att==4)&&(PWRi>=ATT6dB)&&(flag_PTT==1)){                        //при совпадении условий и флага **************************** ATT -6дБ
    flag_inputalarm=1; TONE=2500; Time=50; N=10;                       //устанавливаем флаг "flag_inputalarm" в 1 и включаем прерывистый звуковой сигнал
    tft.drawString("INP PWR Hi!",200,120,4);}                          //выводим надпись "INP PWR Hi!" красным цветом
  if ((flag_autoATT==1)&&(flag_PTT==1)){                               //при совпадении флагов ************************************* ATT AUTO  
  if (PWRi>=ATTauto){ valAutoATT=0; flag_auto3dB=1;                    //если сигнал на входе выше ATTauto, запускаем счётчик времени задержки отключения аттенюатора
    tft.setTextColor(TFT_GREEN,TFT_BLACK);                             //выбираем зелёный цвет текста  
    tft.drawString("ATT   -3dB",200,120,4);                            //выводим надпись "ATT   -3dB" зелёным цветом
    digitalWrite(att3dB,HIGH); digitalWrite(att6dB,LOW);}              //на выходе ATT-3dB высокий уровень, на выходе ATT-6dB низкий
  else if(millis()-AutoATTMillis>=1){                                  //формируем задержку выключения аттенюатора     
    AutoATTMillis=millis(); valAutoATT++;}                             //с каждой миллисекундой увеличиваем значение valAutoATT  
  else {valAutoATT=0;}                                                 //иначе обнуляем счётчик
  if (valAutoATT>=ATTDelay*10){valAutoATT=0; flag_auto3dB=0;}          //как только значение valAutoATT становится равным TimeAutoATT*10 
  if (PWRi>=ATTalarm){flag_inputalarm=1; TONE=2500; Time=50; N=10;     //если сигнал на входе выше ATTalarm, включаем прерывистый звуковой сигнал
    tft.setTextColor(TFT_RED,TFT_BLACK);                               //выбираем красный цвет текста  
    tft.drawString("INP PWR Hi!",200,120,4);}}                         //выводим надпись "INP PWR Hi!" красным цветом
//***************************************************************************************************************************************** Режим VOX
  switch (vox) {                                                       //длинным нажатием переключаем режим "VOX"
    case 1: flag_vox=0; break;                                         //выбор режима VOX по длинному нажатию, flag_vox в 0
    case 2: flag_vox=1; break;}}                                       //выбор режима VOX по длинному нажатию, flag_vox в 1
    tft.setTextPadding(55);                                            //включаем обновление подложки шрифта
  if ((flag_mode==5)&&(flag_band_switch==1)){ DelayPtt++;              //при переключении диапазона в режиме "AUTO" и "VOX" блокируем PTT
  if (DelayPtt>1){DelayPtt=0; flag_band_switch=0;}}                    //когда счётчик отсчитает два обнуляем его и "flag_band_switch"
  if ((flag_power==1)&&(flag_vox==1)){                                 //при совпадении флагов
  if (((flag_mode==5)&&(frq_vox>16)&&(flag_band_switch==0))||          //либо VOX срабатывает с задержкой на переключение диапазона от входной частоты в режиме "AUTO"
    ((flag_mode<4)&&(frq>16)))                                         //либо в остальных режимах VOX срабатывает от частоты входного сигнала
    {tft.setTextColor(TFT_RED,TFT_BLACK); frq_vox=frq_vox/10;          //выбираем цвет текста
    tft.drawCentreString("TX",440,120,4); valvox=0;                    //выводим надпись "TX" вместо "VOX", обнуляем счётчик времени задержки отпускания VOX
    digitalWrite(TX,HIGH); flag_PTT=1;}                                //на выходе PTT высокий уровень, флаг "flag_PTT" устанавливаем в 1
  if(millis()-VoxMillis>=1){                                           //формируем задержку выключения PTT в режиме VOX
    VoxMillis=millis(); valvox++;}                                     //с каждой миллисекундой увеличиваем значение valvox
  else {valvox=0;}                                                     //иначе обнуляем счётчик
  if (valvox>=VOXDelay){valvox=0; frq_vox=0;                           //как только значение valvox становится равным VOXDelay обнуляем счётчик и "frq_vox"
    tft.setTextColor(TFT_GREEN,TFT_BLACK);                             //выбираем цвет текста
    tft.drawCentreString("VOX",440,120,4); digitalWrite(TX,LOW);}}     //выводим надпись "VOX" вместо "TX", на выходе PTT низкий уровень
  if((flag_PTT==0)&&(flag_vox==0)){tft.drawCentreString("",440,120,4);}//при совпадении флагов затираем надпись TX
//**************************************************************************************************************************************** Педаль PTT
    bool pedal=digitalRead(pttIN);                                     //считываем состояние порта педали ptt
    tft.setTextPadding(50); tft.setTextColor(TFT_RED,TFT_BLACK);       //включаем обновление подложки шрифта и выбираем цвет текста
  if((pedal==0)&&(flag_vox==0)&&(flag_power==1)&&(flag_band_switch==0))//если на порту низкий уровень и совпадают "flag_vox==0" и "flag_power==1"
    { digitalWrite(TX,HIGH);                                           //на выходе TX высокий уровень  
    tft.drawCentreString("TX",440,120,4); flag_PTT=1;}                 //выводим надпись TX и устанавливаем "flag_PTT" в 1  
  else if ((flag_vox==0)&&(flag_power==1)){butptt();}                  //иначе обращаемся к подпрограмме butptt
//**************************************************************************************************************************************** Кнопка PTT
  switch(button4.Loop()){                                              //описываем работу кнопки "PTT"
    case SB_CLICK: if((flag_power==1)&&(flag_vox==0)){PTT++; beeper();}//определяем алгоритм работы кнопки "PTT" по короткому нажатию с бипером
  if (PTT>2){PTT=1;} break;
    case SB_LONG_CLICK: pwr_view++; beeper();                          //определяем алгоритм работы кнопки "PWR_VIEW" по длинному нажатию
    tft.fillRect(20,11,420,24,TFT_BLACK);                              //затираем строку
  if (pwr_view>2){pwr_view=1;} break;}
  if (pwr_view==1){my_temp=(float)get3231Temp();}                      //если "pwr_view=1" выводим либо часы, либо позывной
//******************************************************************************************************************************** Управление бипером
  if (beep==1){flag_beeper=0;}
  if (beep==2){flag_beeper=1; symbol_speaker();}
}void beeper(){
  if ((flag_beeper==1)||(flag_band_switch==1)){tone4.tone(Tonbeep*100);//если состояние флага "flag_beeper==1", устанавливаем тональность бипера Tonbeep
    delay(50); tone4.noTone();}}                                       //формируем длительность бипера 50мс, отключаем бипер
//*************************************************************************************************************************** Подпрограмма кнопки PTT    
void butptt(){
  switch(PTT){                                                         
    case 1: digitalWrite(TX,HIGH);                                     //выводим на вывод PTT высокий уровень 
    tft.drawCentreString("TX",440,120,4); flag_PTT=1; break;           //выводим надпись "TX", "flag_PTT" устанавливаем в 1
    case 2: digitalWrite(TX,LOW); flag_PTT=0;                          //выводим на вывод PTT низкий уровень, "flag_PTT" сбрасываем в 0
    tft.drawCentreString("",440,120,4); break;}}                       //затираем надпись "TX"
void symbol_speaker(){//************************************************************************************************************* Символ динамика
    tft.fillRect(444,20,3,10,TFT_GREEN);                               //рисуем "магнит" динамика
    tft.fillRect(448,19,6,12,TFT_GREEN);                               //Рисуем "диффузор"
    tft.fillTriangle(448,19,454,19,454,13,TFT_GREEN);                  //---------------
    tft.fillTriangle(448,30,454,30,454,36,TFT_GREEN);                  //---------------
    tft.drawPixel(455,24,TFT_GREEN); tft.drawPixel(455,26,TFT_GREEN);  //рисуем "звуковые волны"
    tft.drawPixel(456,22,TFT_GREEN); tft.drawPixel(456,28,TFT_GREEN);  //---------------------
    tft.drawPixel(457,23,TFT_GREEN); tft.drawPixel(457,27,TFT_GREEN);  //---------------------
    tft.drawLine(458,24,458,26,TFT_GREEN);                             //---------------------
    tft.drawPixel(458,20,TFT_GREEN); tft.drawPixel(458,30,TFT_GREEN);  //---------------------
    tft.drawPixel(459,21,TFT_GREEN); tft.drawPixel(459,29,TFT_GREEN);  //---------------------
    tft.drawPixel(460,22,TFT_GREEN); tft.drawPixel(460,28,TFT_GREEN);  //---------------------
    tft.drawLine(461,23,461,27,TFT_GREEN);}                            //--------------------- 
void symbol_fan(){//************************************************************************************************************** Символ вентилятора
    tft.fillCircle(380,130,3,TFT_GREEN);                               //рисуем центр
    tft.fillCircle(380,120,5,TFT_GREEN);                               //рисуем лопасти
    tft.fillCircle(371,135,5,TFT_GREEN);                               //--------------
    tft.fillCircle(389,135,5,TFT_GREEN);                               //-------------- 
}//********************************************************************************************************************************************** АLC
void alc(float U6){
    float vout_alc=(U6*5.0)/1024.0;                                    //привязываем U4 к пяти вольтам
    int a=vout_alc*4.9;                                                //назначаем переменную "a" градусника ALC
  for(int i=0; i<a; i++){                                              //включаем цикл рисования кубиков
  if (i>17){
    tft.fillRect(242+i*9,210,5,14,TFT_RED);}                           //рисуем градусник красного цвета пропорционально ALC
  else { tft.fillRect(242+i*9,210,5,14,TFT_GREEN);}}                   //рисуем градусник зелёного цвета пропорционально ALC   
  for(int j=a; j<25; j++){                                             //включаем цикл рисования кубиков подложки и стирания
    tft.fillRect(242+j*9,210,5,14,TFT_GREY40);}                        //дорисовываем подложку до конца    
}//**************************************************************************************************************************************** Амперметр
void energy(float I4,float U4,float U1,float U2){
    tft.setTextPadding(75);                                            //включаем обновление подложки шрифта
  if (I4<0){I4=0;}                                                     //исключаем измерение отрицательных значений
  if (I4<Imax){tft.setTextColor(TFT_GREEN,TFT_BLACK);}                 //если "I4<Imax" выбираем зелёный цвет текста
  if (I4>Imax){tft.setTextColor(TFT_RED,TFT_BLACK);}                   //если "I4>Imax" выбираем красный цвет текста
    char bufA[5]; byte lenA=4; dtostrf(I4,lenA,1,bufA);                //конвертируем символьный массив вывода данных 
    bufA[lenA]='A'; bufA[lenA+1]=0;                                    //потребляемого тока усилителя мощности
    tft.drawCentreString(bufA,195,286,4);                              //выводим значение тока зелёного цвета с добавлением "A"
    tft.setFreeFont(FSSB12); tft.setTextPadding(0);                    //выбираем шрифт и выключаем обновление подложки шрифта
    tft.drawString("I :",135,288,1);                                   //выводим символ "I :"
  if ((I4>=Imax)&&(statealarm==false)){flag_curalarm=1;                //при превышении потребляемого тока устанавливаем "flag_curalarm" в 1
    tft.setTextPadding(158); TONE=1000; Time=120; N=4;                 //включаем обновление подложки шрифта, выбираем тон сигнала
    tft.drawString("HIGH Current!",200,120,4);}                        //выводим надпись "HIGH Current!" красным цветом
//***************************************************************************************************************************************** Вольтметр
    tft.setTextPadding(75);                                            //включаем обновление подложки шрифта
    float vout=(U4*5.0)/1024.0;                                        //привязываем U4 к пяти вольтам
    vin=vout/(divider/(R1+divider));                                   //привязываем к делителю
  if (vin<0.09){vin=0.0;}                                              //обнуляем нежелательные значения
  if ((vin>=Vmin)&&(vin<=Vmax)){tft.setTextColor(TFT_GREEN,TFT_BLACK);}//если напряжение находится вне аварийной зоны выбираем зелёный цвет текста
  else {tft.setTextColor(TFT_RED,TFT_BLACK);}                          //иначе выбираем красный цвет текста
    char bufV[5]; byte lenV=4; dtostrf(vin,lenV,1,bufV);               //конвертируем символьный массив вывода данных
    bufV[lenV]='V'; bufV[lenV+1]=0;                                    //напряжения питания усилителя мощности
    tft.drawCentreString(bufV,317,286,4);                              //выводим значение напряжения с добавлением "V"
    tft.setFreeFont(FSSB12); tft.setTextPadding(0);                    //выбираем шрифт и выключаем обновление подложки шрифта
    tft.drawString("U :",250,288,1);                                   //выводим символ "U :"
    tft.setTextPadding(158); tft.setTextColor(TFT_RED,TFT_BLACK);      //выбираем красный цвет текста, включаем обновление подложки шрифта  
  if ((vin>Vmax)&&(statealarm==false)){flag_voltagealarm=1;            //при превышении напряжения устанавливаем "flag_voltagealarm" в 1
    TONE=1500;Time=100;N=5;tft.drawString("HIGH Voltage!",200,120,4);} //выбираем тон сигнала, выводим надпись "HIGH Voltage!" красным цветом
  if ((vin<Vmin)&&(statealarm==false)){flag_voltagealarm=1;            //при снижении напряжения ниже минимального устанавливаем "flag_voltagealarm" в 1
    TONE=1500;Time=100;N=5; tft.drawString("LOW Voltage!",200,120,4);} //выбираем тон сигнала, выводим надпись "LOW Voltage!!" красным цветом
    tft.setFreeFont(FSSB9); tft.setTextColor(TFT_DARKGREY);            //выбираем шрифт и цвет текста
    tft.drawNumber(Vmin,250,265,1);                                    //выводим значение минимального напряжения
    tft.drawNumber(Vmax,315,265,1);                                    //выводим значение максимального напряжения
    tft.drawCentreString(".....",297,265,1);                           //выводим многоточие
    tft.drawString("V",270,265,1);                                     //выводим "V"
    tft.drawString("V",335,265,1);                                     //выводим "V"
//************************************************************************************************************* Выходная мощность 250_500_1000_2000Вт
    float A; int B,C,D;                                                //переменные выбора мощности
  if (Scale==1){A=22.361; B=250; C=5;  D=5;}                           //если выбрана выходная мощность 250Вт "Scale==1"
  if (Scale==2){A=31.63;  B=500; C=10; D=10;}                          //если выбрана выходная мощность 500Вт "Scale==2"
  if (Scale==3){A=44.722; B=500; C=10; D=20;}                          //если выбрана выходная мощность 1000Вт "Scale==3"
  if (Scale==4){A=63.25;  B=500; C=10; D=40;}                          //если выбрана выходная мощность 2000Вт "Scale==4"
    float Vf=((U1*5)/1023)*A;                                          //приводим напряжение U1 к выбранной выходной мощности(переменная "А")
    PWR=(Vf*Vf)/B;                                                     //вычисляем выходную мощность(переменная "В")
    PWRf=PWR*C;                                                        //округляем значение мощности кратно переменной "С"
    int a=PWRf/D;                                                      //определяем число кубиков в градуснике (PWRf/D=50)
  for(int i=0; i<a; i++){                                              //включаем цикл рисования кубиков
    tft.fillRect(17+i*9,65,5,25,TFT_GREEN);}                           //рисуем градусник зелёного цвета пропорционально мощности
  for(int j=a; j<50; j++){                                             //включаем цикл рисования кубиков подложки и стирания
    tft.fillRect(17+j*9,65,5,25,TFT_GREY40);}                          //дорисовываем подложку до конца
//************************************************************************************************************************* Входная мощность 30_120Вт      
  if (flag_power==0){                                                  //если включен BYPASS
    float Vi=((U2*5)/1023)*h;                                          //приводим напряжение к мощности 120Вт 
    PWRi=(Vi*Vi)/50;                                                   //вычисляем мощность    
    int b=PWRi/4;                                                      //назначаем переменную "b" градусника input_pwr 120Вт
  for(int i=0; i<b; i++){                                              //включаем цикл рисования кубиков
    tft.fillRect(197+i*9,182,5,23,TFT_SILVER);}                        //рисуем градусник серебряного цвета пропорционально мощности
  for(int j=b; j<30; j++){                                             //включаем цикл рисования кубиков подложки и стирания
    tft.fillRect(197+j*9,182,5,23,TFT_GREY40);}                        //дорисовываем подложку до конца
    digitalWrite(att3dB,LOW);digitalWrite(att6dB,LOW);}                //на выходах ATT-3dB и ATT-6dB низкие уровени  
  if (flag_power==1) {float Vi=((U2*5)/1023)*l;                        //если включен POWER ON
    PWRi=(Vi*Vi)/50;                                                   //вычисляем мощность до 30Вт 
    int b=PWRi;                                                        //назначаем переменную "b" градусника input_pwr 30Вт
  for(int i=0; i<b; i++){                                              //включаем цикл рисования кубиков
    tft.fillRect(197+i*9,182,5,23,TFT_YELLOW);}                        //рисуем градусник желтого цвета пропорционально мощности
  for(int j=b; j<30; j++){                                             //включаем цикл рисования кубиков подложки и стирания
    tft.fillRect(197+j*9,182,5,23,TFT_GREY40);}}                       //дорисовываем подложку до конца
//************************************************************************************************ Подводимая мощность, КПД и коэффициент усиления УМ
    Psupply=vin*I4;                                                    //высчитываем подводимую мощность
    u=(PWRf/Psupply)*100;                                              //высчитываем КПД
  if (u>=100){u=100;}                                                  //ограничиваем показания КПД сверху
  if (Psupply==0){u=0;}                                                //ограничиваем показания КПД снизу
    float Kp=(float)PWRf/(float)PWRi;                                  //вычисляем коэффициент усиления
  if (PWRi==0){Kp=0;}                                                  //ограничиваем показания коэффициента усиления снизу
  if (pwr_view==2){ my_temp=(float)get3231Temp();                      //если выбрана информационная строка
    tft.setTextColor(TFT_SILVER);                                      //выбираем цвет текста
    tft.drawString("Pout=",20,10,2);                                   //выводим надпись "Pout="      
    tft.drawString("Pin=",125,10,2);                                   //выводим надпись "Pin="
    tft.drawString("Kp=",205,10,2);                                    //выводим надпись "Kp="
    tft.drawString("Psup=",270,10,2);                                  //выводим надпись "Psup="      
    tft.drawString("u=",365,10,2);                                     //выводим надпись "u="
    tft.setTextColor(TFT_SILVER,TFT_BLACK);                            //выбираем цвет текста с цветом подложки
    tft.setTextPadding(40); tft.drawFloat(Kp,1,230,10,2);              //выводим значение коэффициента усиления
    char bufW[5]; byte lenW=4;                                         //конвертируем символьный массив
    dtostrf(PWRf,lenW,0,bufW);                                         //вывода данных 
    bufW[lenW]='W'; bufW[lenW+1]=0;                                    //выходной мощности усилителя
    tft.drawString(bufW,55,10,2);                                      //выводим значение выходной мощности с добавлением "W"
    char buf[5]; byte len=4; dtostrf(PWRi,len,0,buf);                  //конвертируем символьный массив
    buf[len]='W'; buf[len+1]=0;                                        //входной мощности усилителя
    tft.drawString(buf,150,10,2);                                      //выводим значение входной мощности 30Вт и 120Вт с добавлением "W"
    char bufP[5]; byte lenP=4; dtostrf(Psupply,lenP,0,bufP);           //конвертируем символьный массив вывода данных
    bufP[lenP]='W'; bufP[lenP+1]=0;                                    //подводимой мощности
    tft.drawString(bufP,305,10,2);                                     //выводим подводимую мощность с добавлением "W"
    char bufu[5]; byte lenu=4; dtostrf(u,-lenu,1,bufu);                //конвертируем символьный массив 
    bufu[lenu]='%'; bufu[lenu+1]=0;                                    //вывода данных КПД
    tft.drawString(bufu,380,10,2);}}                                   //выводим значение КПД с добавлением "%"       
void set_temp(){//********************************************************************************************** Датчик DS18B20 температура радиатора
//    byte data[0];                                                      //выделяем два байта для чтения массива данных из датчика
//    ds.reset();                                                        //сбрасываем датчик температуры
//    ds.write(0xCC);                                                    //пропускаем поиск ROM, так как на шине один датчик
//    ds.write(0x44);                                                    //запускаем конвертацию температуры датчиком
//    ds.reset();                                                        //сбрасываем датчик температуры
//    ds.write(0xCC);                                                    //пропускаем поиск ROM
//    ds.write(0xBE);                                                    //считываем ОЗУ датчика
//    data[0] = ds.read (); data[1] = ds.read ();                        //считываем побайтно озу датчика
//    int16_t raw = (data[1] << 8) | data[0];                            //конвертируем полученные данные
//    float temp = (float)raw / 16.0;                                    //приводим значение температуры к градусам цельсия 

    byte data[0];                                                        //выделяем два байта для чтения массива данных из датчика
  if(millis()-dsLastUpdateTime>DS_UPDATE_TIME){                          //если текущее значение времени больше заданного DS_UPDATE_TIME
    dsLastUpdateTime=millis();                                           //выравниваем значения dsLastUpdateTime с текущим значением времени
    ds.reset();                                                          //сбрасываем датчик температуры
    ds.write(0xCC);                                                      //пропускаем поиск ROM, так как на шине один датчик
    ds.write(0x44);                                                      //запускаем конвертацию температуры датчиком
    ds.reset();                                                          //сбрасываем датчик температуры
    ds.write(0xCC);                                                      //пропускаем поиск ROM
    ds.write(0xBE);                                                      //считываем ОЗУ датчика
    data[0] = ds.read(); data[1] = ds.read();                            //читаем из датчика два байта значений температуры
    int16_t raw=(data[1]<<8)|data[0];                                    //конвертируем полученные данные
    temp=(float)raw/16.0;}                                               //приводим значение температуры к градусам цельсия

    tft.setTextPadding(50);                                            //включаем обновление подложки шрифта
  if (temp<TFanMax){tft.setTextColor(TFT_GREEN,TFT_BLACK);}            //если "temp<TFanMax" выбираем зелёный цвет текста
  if (temp>=TFanMax){tft.setTextColor(TFT_RED,TFT_BLACK);}             //если "temp>=TFanMax" выбираем красный цвет текста
    tft.setFreeFont(FSSB12); tft.setTextPadding(0);                    //выбираем шрифт и выключаем обновление подложки шрифта
    char buf[5]; byte len = 4; dtostrf(temp,-len,1,buf);               //конвертируем символьный массив
    buf[len] = 'C'; buf[len+1] = 0;                                    //вывода данных температуры
    Wire.requestFrom(104,2);                                           //получаем данные с адреса 104 I2C
  if(Wire.available()) {                                               //если линия I2C отвечает
    tft.drawString("Tr:",365,288,1);                                   //выводим надпись "Tr:"
    tft.drawCentreString(buf,435,286,4);}                              //выводим значение температуры с добавлением "С"
  else {tft.drawString("Tr:",365,288,1);                               //выводим надпись "Tr:"
    tft.drawCentreString(buf,435,286,4);                               //выводим значение температуры с добавлением "С"
    tft.setFreeFont(FSSB9); tft.setTextColor(TFT_DARKGREY);            //выбираем шрифт и цвет текста
    tft.drawCentreString("DS18B20",415,265,1);}                        //выводим надпись "DS18B20"
  if (temp<TFanOff){tft.fillRect(366,115,29,26,TFT_BLACK);             //если температура меньше TFanOff затираем символ вентилятора    
    digitalWrite(Fantemp,LOW);}                                        //на выходе Fantemp низкий уровень                      
  if (temp>=TFanOn){digitalWrite(Fantemp,HIGH); symbol_fan();}         //если температура выше 30грдС выводим символ вентилятора, на выводе Fantemp высокий уровень
  if ((temp>=TFanMax)&&(statealarm==false)){                           //при превышении температуры
    flag_tempalarm=1; TONE=2200; Time=70; N=6;                         //устанавливаем "flag_tempalarm" в 1, выбираем тон сигнала
    tft.setTextColor(TFT_RED,TFT_BLACK);                               //выбираем цвет текста
    tft.setTextPadding(158);tft.drawString("OVERHEAT!!!",200,120,4);}  //включаем обновление подложки шрифта, выводим надпись "OVERHEAT!!!" красным цветом
}//*********************************************************************************************************** Прорисовка шкалы входной мощности 30Вт
void draw_inp_pwr30(){digitalWrite(in120,LOW);                         //выключаем внешний делитель
    tft.fillRect(190,152,250,14,TFT_BLACK);                            //рисуем прямоугольник фона шкалы
    const char*inp_pwr[]={"0","5","10","15","20","25",""};             //создаём массив символов для надстрочных надписей
  for (int i = 0; i < 7; i++){                                         //запускаем цикл
    tft.setFreeFont(FSSB9);                                            //выбираем шрифт текста
  if (i>3){tft.setTextColor(TFT_RED);}                                 //надписи дальше третьей риски красного цвета
  else tft.setTextColor(TFT_GREEN);                                    //иначе зелёного
  if (i<2){tft.drawString(inp_pwr[i],190 + i * 45,152,1);}             //выводим надстрочные символы до третьего
  else tft.drawString(inp_pwr[i],185 + i * 45,152,1);}                 //выводим надстрочные символы с третьего до конца вправо 
}//********************************************************************************************************** Прорисовка шкалы входной мощности 120Вт
void draw_inp_pwr120(){digitalWrite(in120,HIGH);                       //включаем внешний делитель
    tft.fillRect(190,152,250,14,TFT_BLACK);                            //рисуем прямоугольник фона шкалы
    const char*inp_pwr[]={"0","20","40","60","80","100",""};           //создаём массив символов для надстрочных надписей
  for (int i = 0; i < 7; i++){                                         //запускаем цикл
    tft.drawLine(194 + i * 45, 168, 194 + i * 45, 175,TFT_SILVER);     //рисуем двойные 
    tft.drawLine(195 + i * 45, 168, 195 + i * 45, 175,TFT_SILVER);     //вертикальные риски
    tft.setFreeFont(FSSB9);                                            //выбираем шрифт текста
  if (i>3){tft.setTextColor(TFT_RED);}                                 //надписи дальше третьей риски красного цвета
  else tft.setTextColor(TFT_GREEN);                                    //иначе зелёного
  if (i<2){tft.drawLine(195,170+i,465,170+i,TFT_SILVER);}              //рисуем горизонтальную линию для шкалы
  if (i==0){tft.drawString(inp_pwr[i],190 + i * 45,152,1);}            //выводим надстрочный символ 0
  if ((i>0)&&(i<5)){tft.drawString(inp_pwr[i],185 + i * 45,152,1);}    //выводим надстрочные символы до пятого
  if (i==5)tft.drawString(inp_pwr[i],180 + i * 45,152,1);}}            //выводим надстрочные символы с пятого до конца вправо
void draw_out_pwr(){//************************************************************************ Прорисовка шкалы выходной мощности 250_500_1000_2000Вт
    tft.drawLine(15,55,465,55,TFT_SILVER);                             //рисуем двойную горизонтальную линию 
    tft.drawLine(15,56,465,56,TFT_SILVER);                             //для шкалы выходной мощности
    tft.setFreeFont(FSSB9);                                            //выбираем шрифт текста
  for (int i = 0; i < 11; i++){                                        //запускаем цикл
    tft.drawLine(14 + i * 45, 51, 14 + i * 45, 58,TFT_SILVER);         //рисуем двойные 
    tft.drawLine(15 + i * 45, 51, 15 + i * 45, 58,TFT_SILVER);         //вертикальные риски  
  if (Scale==1){ const char*out_pwr[]=                                 //создаём массив символов для надстрочных надписей до 250Вт
    {"  0"," 25"," 50"," 75","100","125","150","175","200","225"," "}; //---------------------------------------------------------
  if (i>7){tft.setTextColor(TFT_RED);}                                 //надписи дальше седьмой риски красного цвета
  else tft.setTextColor(TFT_GREEN);                                    //иначе зелёного
    tft.drawString(out_pwr[i],i * 45,36,1);}                          //выводим надстрочные символы
  if (Scale==2){ const char*out_pwr[]=                                 //создаём массив символов для надстрочных надписей до 500Вт
    {"  0"," 50","100","150","200","250","300","350","400","450"," "}; //---------------------------------------------------------
  if (i>7){tft.setTextColor(TFT_RED);}                                 //надписи дальше седьмой риски красного цвета
  else tft.setTextColor(TFT_GREEN);                                    //иначе зелёного
    tft.drawString(out_pwr[i],i * 45,36,1);}                           //выводим надстрочные символы  
  if (Scale==3){ const char*out_pwr[]=                                 //создаём массив символов для надстрочных надписей до 1000Вт
    {"  0","100","200","300","400","500","600","700","800","900"," "}; //----------------------------------------------------------
  if (i>7){tft.setTextColor(TFT_RED);}                                 //надписи дальше седьмой риски красного цвета
  else tft.setTextColor(TFT_GREEN);                                    //иначе зелёного
    tft.drawString(out_pwr[i],i * 45,36,1);}                           //выводим надстрочные символы  
  if (Scale==4){ const char*out_pwr[]=                                 //создаём массив символов для надстрочных надписей до 2000Вт
    {"  ","0.2","0.4","0.6","0.8","1.0","1.2","1.4","1.6","1.8"," "};  //----------------------------------------------------------
  if (i>7){tft.setTextColor(TFT_RED);}                                 //надписи дальше седьмой риски красного цвета
  else tft.setTextColor(TFT_GREEN);                                    //иначе зелёного
    tft.drawString(out_pwr[i],2+i * 45,36,1);                          //выводим надстрочные символы
    tft.setTextColor(TFT_GREEN); tft.drawString("0",9,36,1);}}         //выводим "0"  
}//********************************************************************************************************* Датчик DS3231 температура внутри корпуса
float get3231Temp(){
    float temp3231;                                                    //переменная температуры DS3231            
    Wire.beginTransmission(104);                                       //посылаем запрос по адресу 104 I2C
    Wire.write(0x11);                                                  //запрос данных в линию I2C
    Wire.endTransmission();                                            //останавливаем передачу данных
    Wire.requestFrom(104,2);                                           //получаем данные с адреса 104 I2C
  if(Wire.available()) {                                               //если линия I2C отвечает
    tMSB = Wire.read();                                                //читаем старший байт
    tLSB = Wire.read();                                                //читаем младший байт
    temp3231 = (tMSB & B01111111);                                     //конвертируем старший байт
    temp3231 += ( (tLSB >> 6) * 0.25 );                                //конвертируем младший байт, получаем температуру
    realtime();                                                        //вызываем подпрограмму часов
    tft.setTextPadding(50);                                            //включаем обновление подложки шрифта
    tft.setTextColor(TFT_DARKGREY,TFT_BLACK);                          //выбираем цвет текста
    char buf[5]; byte len = 4; dtostrf(my_temp,-len,1,buf);            //конвертируем символьный массив
    buf[len] = 'C'; buf[len+1] = 0;                                    //вывода данных температуры
    tft.drawCentreString(buf,435,261,4);                               //выводим значение температуры с добавлением "С"
    tft.setFreeFont(FSSB12);                                           //выбираем шрифт
    tft.setTextPadding(0); tft.drawString("Tc:",365,263,1);}           //выводим надписьи "Tc:"
  else { if (pwr_view==1){                                             //при отключенном модуле DS3231 и выбранных часах
    tft.setFreeFont(FSSB9); tft.setTextColor(TFT_PINK);                //выбираем шрифт и цвет текста
    tft.drawCentreString("-- PA Control Unit D0ITC --",240,15,1);}}    //выводим надпись "-- PA Control Unit D0ITC --"
  return temp3231;                                                     //ничего не выводим
}//*************************************************************************************************************************** Часы реального времени
void realtime(){
    tmElements_t tm;                                                   //переменная установки даты и времени
    int xpos=50;                                                       //начальная координата по х для вывода часов
    int ypos=10;                                                       //начальная координата по y для вывода часов
    int ysecs=ypos;                                                    //координата по х для вывода секунд
    int xsecs=0;                                                       //координата по y для вывода секунд
    int xpos1=303;                                                     //начальная координата по х для вывода даты
    int ypos1=10;                                                      //начальная координата по y для вывода даты
    int yYear=ypos1;                                                   //координата по х для вывода года
    int xYear=0;                                                       //координата по y для вывода года
    int hh,mm,ss,dy,da,mo,ya;                                          //переменные времени и даты
    RTC.read(tm);                                                      //переменная чтения даты и времени
    hh=tm.Hour;                                                        //выводим часы      
    mm=tm.Minute;                                                      //выводим минуты
    ss=tm.Second;                                                      //выводим секунды
    dy=tm.Wday;                                                        //выводим день недели
    da=tm.Day;                                                         //выводим число
    mo=tm.Month;                                                       //выводим месяц
    ya=tm.Year+1970;                                                   //выводим год
  if (pwr_view==1){                                                    //при включенном режиме часов
  if (TimeBeep==2){                                                    //при включенном режиме "TimeBeep" выводим символ
    tft.fillCircle(23,20,3,TFT_PINK);                                  //рисуем центр
    tft.drawPixel(30,19,TFT_PINK); tft.drawPixel(30,21,TFT_PINK);      //рисуем "звуковые волны"
    tft.drawPixel(31,17,TFT_PINK); tft.drawPixel(31,23,TFT_PINK);      //---------------------
    tft.drawPixel(32,18,TFT_PINK); tft.drawPixel(32,22,TFT_PINK);      //---------------------
    tft.drawLine(33,19,33,21,TFT_PINK);                                //---------------------
    tft.drawPixel(33,15,TFT_PINK); tft.drawPixel(33,25,TFT_PINK);      //---------------------
    tft.drawPixel(34,16,TFT_PINK); tft.drawPixel(34,24,TFT_PINK);      //---------------------
    tft.drawPixel(35,17,TFT_PINK); tft.drawPixel(35,23,TFT_PINK);      //---------------------
    tft.drawLine(36,18,36,22,TFT_PINK);}                               //--------------------- 
    tft.setTextColor(TFT_PINK,TFT_BLACK);                              //выбираем цвет часов
    tft.setTextPadding(20);                                            //включаем обновление подложки шрифта
  if (hh < 10) xpos += tft.drawChar('0',xpos,ypos,4);                  //если показания часов меньше 10 дорисовываем незначащий ноль
    xpos += tft.drawNumber(hh,xpos,ypos,4);                            //выводим значение часов
    xpos += tft.drawChar(':',xpos,ypos,4);                             //рисуем часовое и минутное двоеточие
  if (mm < 10) xpos += tft.drawChar('0',xpos,ypos,4);                  //если показания минут меньше 10 дорисовываем незначащий ноль
    xpos += tft.drawNumber(mm,xpos,ypos,4);                            //выводим значение минут
    xsecs = xpos;
    xpos += tft.drawChar(':',xsecs,ysecs,4);                           //рисуем секундное двоеточие
  if (ss < 10) xpos += tft.drawChar('0',xpos,ypos,4);                  //если показания секунд меньше 10 дорисовываем незначащий ноль
    tft.drawNumber(ss,xpos,ysecs,4);                                   //выводим значение секунд
  if (da < 10) xpos1 += tft.drawChar('0',xpos1,ypos1,4);               //если показания числа меньше 10 дорисовываем незначащий ноль
    xpos1 += tft.drawNumber(da,xpos1,ypos1,4);                         //выводим значение числа
    xpos1 += tft.drawChar('-',xpos1,ypos1,4);                          //формируем пробел между числом и месяцем
  if (mo < 10) xpos1 += tft.drawChar('0',xpos1,ypos1,4);               //если показания месяца меньше 10 дорисовываем незначащий ноль
    xpos1 += tft.drawNumber(mo,xpos1,ypos1,4);                         //выводим значение месяца
    xYear = xpos1;
    xpos1 += tft.drawChar('-',xYear,yYear,4);                          //формируем пробел между месяцем и годом
    tft.drawNumber(ya,xpos1,yYear,4);                                  //выводим значение года
    tft.setTextPadding(60);                                            //включаем обновление подложки шрифта
  if (Length==2){                                                      //если "Length==2" выводим сокращённые названия дней недели
  switch (dy) {                                                        //--- дни недели ---
    case 1: tft.drawCentreString("-- Mon --",225,10,4); break;         //выводим понедельник
    case 2: tft.drawCentreString("-- Tue --",225,10,4); break;         //выводим вторник
    case 3: tft.drawCentreString("-- Wed --",225,10,4); break;         //выводим среда
    case 4: tft.drawCentreString("-- Thu --",225,10,4); break;         //выводим четверг
    case 5: tft.drawCentreString("-- Fri --",225,10,4); break;         //выводим пятница
    case 6: tft.drawCentreString("-- Sat --",225,10,4); break;         //выводим суббота
    case 7: tft.drawCentreString("-- Sun --",225,10,4); break;}}       //выводим воскресенье
    tft.setTextPadding(100);                                           //включаем обновление подложки шрифта
  if (Length==1){                                                      //если "Length==1" выводим полные названия дней недели
  switch (dy) {                                                        //--- дни недели ---
    case 1: tft.drawCentreString("Monday",225,10,4);    break;         //выводим понедельник
    case 2: tft.drawCentreString("Tuesday",225,10,4);   break;         //выводим вторник
    case 3: tft.drawCentreString("Wednesday",225,10,4); break;         //выводим среда
    case 4: tft.drawCentreString("Thursday",225,10,4);  break;         //выводим четверг
    case 5: tft.drawCentreString("Friday",225,10,4);    break;         //выводим пятница
    case 6: tft.drawCentreString("Saturday",225,10,4);  break;         //выводим суббота
    case 7: tft.drawCentreString("Sunday",225,10,4);    break;}}}      //выводим воскресенье 
  if (((mm==15)||(mm==30)||(mm==45))&&(ss==0)){                        //каждые 15 минут в 0сек 
    flag_clock++; TONE=1200; Time=50; N=1;}                            //включаем короткий тональный сигнал
  if ((mm==0)&&(ss==0)){flag_clock++; TONE=1200; Time=200; N=1;}       //каждый час в 0сек включаем длинный тональный сигнал
  if (((mm==15)||(mm==30)||(mm==45)||(mm==0))&&(ss==1)){flag_clock=0;} //в 1 сек сбрасываем "flag_clock=0"
}//******************************************************************************************************************** Подпрограмма возврата из меню
void preparing_the_screen(){
    band=EEPROM.read(0);                                               //читаем состояние выбранного диапазона из нулевой ячейки EEPROM
    mode_band=EEPROM.read(1);                                          //читаем состояние выбранного режима переключения диапазонов из первой ячейки EEPROM
    att=EEPROM.read(2);                                                //читаем состояние аттенюаторов из второй ячейки EEPROM
    vox=EEPROM.read(3);                                                //читаем состояние VOX из третьей ячейки EEPROM
    beep=EEPROM.read(4);                                               //читаем из 4 ячейки EEPROM состояние beep
    pwr_view=EEPROM.read(5);                                           //читаем из 5 ячейки EEPROM состояние pwr_view
    tft.invertDisplay(EEPROM.read(6));                                 //читаем содержимое ячейки 6 и выводим нормальный или инверсный цвет дисплея
    RefreshTime=EEPROM.read(7);                                        //читаем из 7 ячейки EEPROM состояние RefreshTime
    Acs=EEPROM.read(8);                                                //читаем из 8 ячейки EEPROM состояние Acs
    Length=EEPROM.read(9);                                             //читаем из 9 ячейки EEPROM состояние Length
    VOXDelay=EEPROM.read(10);                                          //читаем из 10 ячейки EEPROM состояние TimeVox
    ATTDelay=EEPROM.read(11);                                          //читаем из 11 ячейки EEPROM состояние TimeAutoATT
    Imax=EEPROM.read(12);                                              //читаем из 12 ячейки EEPROM состояние Imax
    Vmin=EEPROM.read(13);                                              //читаем из 13 ячейки EEPROM состояние Vmin
    Vmax=EEPROM.read(14);                                              //читаем из 14 ячейки EEPROM состояние Vmax
    TFanOff=EEPROM.read(15);                                           //читаем из 15 ячейки EEPROM состояние TFanOff
    TFanOn=EEPROM.read(16);                                            //читаем из 16 ячейки EEPROM состояние TFanOn
    TFanMax=EEPROM.read(17);                                           //читаем из 17 ячейки EEPROM состояние TFanMax
    BandDelay=EEPROM.read(18);                                         //читаем из 18 ячейки EEPROM состояние BandDelay
    tft.setRotation(EEPROM.read(19));                                  //читаем содержимое ячейки 19 и выводим ориентацию дисплея
    ATToff=EEPROM.read(20);                                            //читаем из 20 ячейки EEPROM состояние ATToff
    ATT3dB=EEPROM.read(21);                                            //читаем из 21 ячейки EEPROM состояние ATT3dB
    ATT6dB=EEPROM.read(22);                                            //читаем из 22 ячейки EEPROM состояние ATT6dB
    ATTauto=EEPROM.read(23);                                           //читаем из 23 ячейки EEPROM состояние ATTauto
    ATTalarm=EEPROM.read(24);                                          //читаем из 24 ячейки EEPROM состояние ATTalarm
    TimeBeep=EEPROM.read(25);                                          //читаем из 25 ячейки EEPROM состояние TimeBeep
    Tonbeep=EEPROM.read(26);                                           //читаем из 26 ячейки EEPROM состояние Tonbeep
    EEPROM.get(27,SWRmax);                                             //читаем из 27-30 ячеек EEPROM состояние SWRmax
    EEPROM.get(31,divider);                                            //читаем из 31-34 ячеек EEPROM состояние divider
    Scale=EEPROM.read(35);                                             //читаем из 35 ячейки EEPROM состояние Scale
    BORDER=EEPROM.read(36);                                            //читаем из 36 ячейки EEPROM состояние BORDER
  if (Acs==2){sensor.setSensitivity(ACS712_20_AMPERS);}                //если Acs=2 выбираем ACS712_20
  if (Acs==1){sensor.setSensitivity(ACS712_30_AMPERS);}                //если Acs=1 выбираем ACS712_30
  if (Acs==3){sensor.setSensitivity(ACS758_50_AMPERS);}                //если Acs=3 выбираем ACS758_50
    sensor.calibrate();                                                //калибровка датчика ACS712
    band_get=band;                                                     //чтобы при первом переключении в режиме "AUTO BAND" небыло двух "пиков"
//********************************************************************************************************************************* Подготовка экрана
  if (BORDER==1){BORDER=TFT_GREEN;}                                    //если BORDER==1 включается зелёный цвет окантовок рамки
  if (BORDER==2){BORDER=TFT_SILVER;}                                   //если BORDER==2 включается серебряный цвет окантовок рамки
  if (BORDER==3){BORDER=TFT_PINK;}                                     //если BORDER==3 включается розовый цвет окантовок рамки
    flag_mode_band=1;                                                  //чтобы при выходе из меню отображался "mode_band"
    tft.fillScreen(TFT_GREY60);                                        //заливаем экран серым цветом
    tft.fillRoundRect(6,6,468,96,8,TFT_BLACK);                         //рисуем черный прямоугольник вывода информации о выходной мощности
    tft.fillRoundRect(8,108,170,56,5,TFT_BLACK);                       //рисуем черный прямоугольник для кнопки "BYPASS/POWER ON"
    tft.fillRoundRect(6,170,174,58,8,TFT_BLACK);                       //рисуем черный прямоугольник вывода информации о КСВ
    tft.fillRoundRect(184,106,290,124,8,TFT_BLACK);                    //рисуем черный прямоугольник вывода информации о входной мощности
    tft.fillRoundRect(6,234,115,80,8,TFT_BLACK);                       //рисуем черный прямоугольник вывода информации о диапазонах
    tft.fillRoundRect(125,234,113,80,8,TFT_BLACK);                     //рисуем черный прямоугольник вывода информации о потребляемом токе
    tft.fillRoundRect(242,234,115,80,8,TFT_BLACK);                     //рисуем черный прямоугольник вывода информации о напряжении питания
    tft.fillRoundRect(361,234,113,80,8,TFT_BLACK);                     //рисуем черный прямоугольник вывода информации о температуре   
  for(int i=0; i<2; i++){                                              //включаем цикл
    tft.drawRect(0+i,0+i,480-i*2,320-i*2,BORDER);                      //рисуем наружную окантовку  
    tft.drawRoundRect(6+i,6+i,468-i*2,96-i*2,8-i,BORDER);              //рисуем внутреннюю окантовку с закруглёнными углами
    tft.drawRoundRect(6+i,106+i,174-i*2,60-i*2,8-i,BORDER);            //рисуем окантовку для кнопки "BYPASS/POWER ON"
    tft.drawRoundRect(6+i,170+i,174-i*2,60-i*2,8-i,BORDER);            //рисуем окантовку для вывода информации о КСВ
    tft.drawRoundRect(184+i,106+i,290-i*2,124-i*2,8-i,BORDER);         //рисуем окантовку для вывода информации о входной мощности
    tft.drawRoundRect(6+i,234+i,115-i*2,80-i*2,8-i,BORDER);            //рисуем окантовку для вывода информации о диапазонах
    tft.drawRoundRect(125+i,234+i,113-i*2,80-i*2,8-i,BORDER);          //рисуем окантовку для вывода информации о потребляемом токе
    tft.drawRoundRect(242+i,234+i,115-i*2,80-i*2,8-i,BORDER);          //рисуем окантовку для вывода информации о напряжении питания
    tft.drawRoundRect(361+i,234+i,113-i*2,80-i*2,8-i,BORDER);}         //рисуем окантовку для вывода информации о температуре
    tft.setFreeFont(FSSB9); tft.setTextColor(TFT_DARKGREY);            //выбираем шрифт и цвет текста
    tft.drawCentreString("ALC",215,210,1);                             //выводим надпись "ALC"
    tft.drawCentreString("CURRENT",180,245,1);                         //выводим надпись "CURRENT"
    tft.drawCentreString("VOLTAGE",297,245,1);                         //выводим надпись "VOLTAGE"
    tft.drawCentreString("TEMP",415,245,1);                            //выводим надпись "TEMP"
    tft.setFreeFont(FSSB12); tft.drawString("SWR = ",27,192,1);        //выбираем шрифт, выводим надпись "SWR = "    
    tft.setTextColor(TFT_RED);tft.drawCentreString("BYPASS",92,128,1); //выбираем цвет текста, выводим надпись "BYPASS"
    draw_inp_pwr120();                                                 //прорисовка шкалы входной мощности 120Вт
    draw_out_pwr();                                                    //прорисовка шкалы выходной мощности 250_500_1000_2000Вт
    tft.setFreeFont(FSSB9); tft.setTextColor(TFT_DARKGREY);            //выбираем шрифт и цвет текста
  if (Acs==2){tft.drawCentreString("ACS712-20",180,265,1);}            //выводим надпись "ACS712-20"
  if (Acs==1){tft.drawCentreString("ACS712-30",180,265,1);}            //выводим надпись "ACS712-30"
  if (Acs==3){tft.drawCentreString("ACS758-50",180,265,1);}            //выводим надпись "ACS758-50"
}//***************************************************************************************************************************************** Конец!!!  
